TEMPLATE = lib
CONFIG += plugin
QT += gui
QT += serialport


INCLUDEPATH+=$$_PRO_FILE_PWD_
INCLUDEPATH+=$$_PRO_FILE_PWD_/plugins
INCLUDEPATH+=$$_PRO_FILE_PWD_/include
INCLUDEPATH+=$$_PRO_FILE_PWD_/src
INCLUDEPATH+=$$_PRO_FILE_PWD_/src/ATBAPP
INCLUDEPATH+=$$_PRO_FILE_PWD_/src/ATBAPP/support
INCLUDEPATH+=$$_PRO_FILE_PWD_/src/ATBAPP/support/VMC

QMAKE_CXXFLAGS += -Wno-deprecated-copy -O

# default
ARCH = PTU5


contains( CONFIG, DesktopLinux ) {
    QMAKE_CC = ccache $$QMAKE_CC
    QMAKE_CXX = ccache $$QMAKE_CXX
    QMAKE_CXXFLAGS += -std=c++17
    # QMAKE_CXXFLAGS += -Wno-deprecated-ctor
    linux-clang {  QMAKE_CXXFLAGS += -Qunused-arguments   }
    ARCH = DesktopLinux
}

contains( CONFIG, PTU5 ) {
    # QMAKE_CC = ccache $$QMAKE_CC
    # QMAKE_CXX = ccache $$QMAKE_CXX
    QMAKE_CXXFLAGS += -std=c++17
    linux-clang {  QMAKE_CXXFLAGS += -Qunused-arguments   }
    CONFIG += link_pkgconfig
    ARCH = PTU5
}

contains( CONFIG, PTU5_YOCTO ) {
    greaterThan(QT_MAJOR_VERSION, 4): QT += serialport
    PTU5BASEPATH = /opt/devel/ptu5
    ARCH = PTU5

    # add qmqtt lib
    #LIBS += -lQt5Qmqtt
}

TARGET   = ATBVMCPlugin
VERSION  = "0.8.0"
INTERFACE = VMCInterface
INTERFACE_DEFINITION = $${PWD}/src/ATBAPP/VMCInterface.h

DEFINES += VMCPLUGIN_LIBRARY

win32 {
    BUILD_DATE=$$system("date /t")
    BUILD_TIME=$$system("time /t")
} else {
    BUILD_DATE=$$system("date +%d%m%y")
    BUILD_TIME=$$system("date +%H%M")
}

GIT_COMMIT=$$system("git log -n 1 --format=oneline | cut -d' ' -f1")
GIT_BRANCH=$$system("git branch --no-color 2> /dev/null | cut -d' ' -f2")
GIT_DESCRIBE=$$system("git describe --dirty --always | tr '-' '_'")

DEV_SUFFIX=""
count(GIT_BRANCH, 2) {
    DEV_SUFFIX="_dev"
}

EXTENDED_VERSION="$${VERSION}-$${GIT_COMMIT}"

CONFIG += c++17

DEFINES+=ATB_QT_VERSION=\\\"$${QT_VERSION}\\\"
DEFINES+=PLUGIN_BUILD_DATE=\\\"$${BUILD_DATE}\\\"
DEFINES+=PLUGIN_BUILD_TIME=\\\"$${BUILD_TIME}\\\"
DEFINES+=PLUGIN_EXTENDED_VERSION=\\\"$${EXTENDED_VERSION}\\\"

DEFINES+=INTERFACE=\\\"VMCInterface\\\"
DEFINES+=INTERFACE_VERSION=\\\"eu.atb.ptu.plugin.VMCInterface/1.0\\\"
DEFINES+=PLUGIN_NAME=\\\"ATBVMCPlugin\\\"
DEFINES+=PLUGIN_VERSION=\\\"$${BUILD_DATE}_$${BUILD_TIME}\\\"
DEFINES+=PLUGIN_GIT_DESCRIBE=\\\"$${GIT_DESCRIBE}_$${GIT_BRANCH}$${DEV_SUFFIX}\\\"

# Default rules for deployment.
#qnx: target.path = /tmp/$${TARGET}/bin
#else: unix:!android: target.path = /opt/$${TARGET}/bin
#!isEmpty(target.path): INSTALLS += target

# ATBAPP interface
HEADERS += \
    src/ATBAPP/VMCInterface.h \
    src/ATBAPP/ATBVMCPlugin.h \
    src/ATBAPP/ATBAPPplugin.h \
    src/ATBAPP/UnifiedDCVMCInterface.h \
    src/ATBAPP/support/VMC/com_interface.h \
    src/ATBAPP/support/VMC/ReceiveBuffer.h \
    src/ATBAPP/support/VMC/SendBuffer.h \
    src/ATBAPP/support/VMC/vmc.h \
    src/ATBAPP/support/VendingData.h

SOURCES += \
    src/ATBAPP/ATBVMCPlugin.cpp \
    src/ATBAPP/support/VMC/com_interface.cpp \
    src/ATBAPP/support/VMC/ReceiveBuffer.cpp \
    src/ATBAPP/support/VMC/SendBuffer.cpp \
    src/ATBAPP/support/VMC/vmc.cpp \
    src/ATBAPP/support/VendingData.cpp
