#ifndef UNIFIED_DCVMC_INTERFACE_H_INCLUDED
#define UNIFIED_DCVMC_INTERFACE_H_INCLUDED

#include <QObject>
#include <QSettings>

#include <QtPlugin>

#include <QSettings>
#include <QString>

#include "ATBAPPplugin.h"


class UnifiedDCVMCInterface : public ATBAPPplugin {
    Q_INTERFACES(ATBAPPplugin)

public:
    explicit UnifiedDCVMCInterface() = default;
    virtual ~UnifiedDCVMCInterface() = default;

    virtual QStringList getPluginInfoList() = 0;
    virtual const QString &getPluginInfo() = 0;

    // mandantory ATBAPP plugin methods:
    virtual PLUGIN_STATE getState() = 0;
    virtual QString const &getLastError() = 0;
    virtual QString const &getLastErrorDescription() = 0;

    virtual PLUGIN_STATE initPlugin(QObject *eventReceiver,
                                    QObject *atbSystem,
                                    QObject *hmiConfig,
                                    QSettings const &settings) = 0;

    virtual PLUGIN_STATE initPlugin(QObject *eventReceiver, QSettings const &settings) = 0;

    virtual PLUGIN_STATE initDCPlugin(QObject *eventReceiver,
                                      const QSettings & settings) = 0;

    virtual PLUGIN_STATE initVMCPlugin(QObject *eventReceiver,
                                       QObject *atbSystem, QObject *hmiConfig,
                                       const QSettings & settings) = 0;


    virtual QString const &getString(RESULT_STATE resultState) = 0;

public slots:
    virtual void onChangedProgramModeToSELL() = 0;
    virtual void onChangedProgramModeToSERVICE() = 0;
    virtual void onChangedProgramModeToIDLE() = 0;
    virtual void onChangedProgramModeToOOO() = 0;

    virtual void startPhysicalLayer() = 0;
    virtual void stopPhysicalLayer() = 0;
    virtual void reboot() = 0;
    virtual void reset() = 0;
};

Q_DECLARE_INTERFACE(UnifiedDCVMCInterface,
                    "eu.atb.ptu.plugin.UnifiedDCVMCInterface/1.0")

#endif // UNIFIED_DCVMC_INTERFACE_H_INCLUDED
