#include "VendingData.h"
#include <QDebug>
#include "ATBAPP.h"

VendingData::VendingData(QObject *parent) : QObject(parent)
{   
    qRegisterMetaType<FormatedStringList>("FormatedStringList");
}


QVariant VendingData::getParameter(const QString & key)
{

    #if defined (ARCH_DesktopLinux)
    // note: QVariant.toString() returns empty string for custom types

    if (QString::compare(hash.value(key).typeName(), "APP_ACTION") == 0) {
        APP_ACTION action = hash.value(key).value<APP_ACTION>();
        qDebug() << "VendingData::getParameter() key = " << key << " value = " << action;
    }
    else {
        qDebug() << "VendingData::getParameter() key = " << key << " value = " << hash.value(key).toString();
    }

    #endif

    return hash.value(key);
}

void VendingData::setParameter(const QString & key, QVariant value)
{

    #if defined (ARCH_DesktopLinux)
    // note: QVariant.toString() returns empty string for custom types
    if (QString::compare(value.typeName(), "APP_ACTION") == 0) {
        APP_ACTION action = value.value<APP_ACTION>();
        qDebug() << "VendingData::setParameter() key = " << key << " value = " << action;
    }
    else {
        qDebug() << "VendingData::setParameter() key = " << key << " value = " << value.toString();
    }

    #endif

    this->hash.insert(key, value);
}

void VendingData::clearParameter(const QString & key)
{
    this->hash.remove(key);
}

bool VendingData::hasParameter(const QString & key)
{
    return hash.contains(key);
}

void VendingData::clear()
{
    this->hash.clear();
}


uint VendingData::getUintParameter(const QString & key)
{
    qDebug() << "VendingData::getUintParameter() key = " << key << " value = " << hash.value(key).toString();

    uint returnValue = 0;
    bool ok;

    returnValue = hash.value(key).toString().toUInt(&ok);
    if (!ok) returnValue = 0;

    return returnValue;
}
